## nvidia-cudnn-frontend 0.8+ds

=== samples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

Include(FetchContent)

# Find the cuda compiler
find_package(CUDAToolkit)

# Fetch and build catch2
FetchContent_Declare(
  Catch2
  GIT_REPOSITORY https://github.com/catchorg/Catch2.git
  GIT_TAG        v3.0.1
)
FetchContent_MakeAvailable(Catch2)

# Find cudnn
include(${CMAKE_SOURCE_DIR}/cmake/cuDNN.cmake)

add_executable(
    samples
    conv_sample.cpp
    resnet_test_list.cpp
    resnet_sample.cpp
    test_list.cpp 
    fp16_emu.cpp 
    helpers.cpp 
    fusion_sample.cpp 
    fp8_sample.cpp 
    mha_sample.cpp
    fused_mha_sample.cpp
)

if(DEFINED ENV{NO_DEFAULT_IN_SWITCH})
    message("Default case in the switch is disabled")
    add_compile_definitions(NO_DEFAULT_IN_SWITCH)
endif()

if (MSVC)
    target_compile_options(
        samples PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
    )
else()
    target_compile_options(
        samples PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()
target_include_directories(samples PRIVATE "resnet_block/include")

target_link_libraries(
    samples
    cudnn_frontend
    Catch2::Catch2WithMain

    CUDA::cudart
    CUDA::cublas
    CUDA::nvrtc
    
    CUDNN::cudnn_all
)

# cuDNN dlopen's its libraries
# Add all libraries in link line as NEEDED
set_target_properties(
    samples
    PROPERTIES
    LINK_WHAT_YOU_USE TRUE
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
)

=== debian/changelog ===
nvidia-cudnn-frontend (0.8+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1031972)

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Feb 2023 00:37:52 -0500

## nvidia-cudnn-frontend 0.9.2%2Bds

=== debian/changelog ===
nvidia-cudnn-frontend (0.9.2+ds-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 0.9.2+ds
    Please pin to this version for PyTorch/v2.1.X
  * add the missing content in copyright

  [ Andreas Beckmann ]
  * add salsa-ci.yml

 -- Mo Zhou <lumin@debian.org>  Wed, 28 Feb 2024 12:08:38 -0500

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,repacksuffix=+ds,dversionmangle=auto" \
https://github.com/NVIDIA/cudnn-frontend/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## nvidia-cudnn-frontend 0.9.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

project(cudnn_frontend VERSION 0.9)

option(CUDNN_FRONTEND_BUILD_SAMPLES "Defines if samples are built or not." ON)

add_library(cudnn_frontend INTERFACE)

target_include_directories(
    cudnn_frontend INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_compile_features(cudnn_frontend INTERFACE cxx_std_11)

if (${CUDNN_FRONTEND_BUILD_SAMPLES})
add_subdirectory(samples)
endif()

=== samples/CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 FetchContent_MakeAvailable(Catch2)
 
 # Find cudnn
-include(${CMAKE_SOURCE_DIR}/cmake/cuDNN.cmake)
+include(${CMAKE_CURRENT_SOURCE_DIR}/../cmake/cuDNN.cmake)
 
 add_executable(
     samples
@@ -27,7 +27,10 @@
     fusion_sample.cpp 
     fp8_sample.cpp 
     mha_sample.cpp
+    norm_samples.cpp
     fused_mha_sample.cpp
+    f16_flash_mha_sample.cpp
+    fp8_flash_mha_sample.cpp
 )
 
 if(DEFINED ENV{NO_DEFAULT_IN_SWITCH})

=== debian/control ===
Source: nvidia-cudnn-frontend
Section: contrib/libdevel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
Standards-Version: 4.6.0
Build-Depends: debhelper-compat (= 13)
Homepage: https://github.com/NVIDIA/cudnn-frontend
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-cudnn-frontend
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-cudnn-frontend.git
Rules-Requires-Root: no

Package: libcudnn-frontend-dev
Section: contrib/libdevel
Architecture: all
Depends: ${misc:Depends}, nvidia-cudnn, nlohmann-json3-dev,
Description: c++ wrapper for the cudnn backend API (development files)
 The cuDNN frontend API is a C++ header-only library that wraps the cuDNN C
 backend API. Both the frontend and backend APIs are entry points to the same
 set of functionality that we commonly refer to as the "graph API".
 .
 While there are two entry points to the graph API (i.e. backend and frontend),
 we expect that most users will use the frontend entry point because:
 .
 It is less verbose without loss of control. All functionality accessible
 through the backend API is also accessible through the frontend API.  It adds
 functionality on top of the backend API, like errata filters and autotuning.
 Also, for those who want to use the backend API, the frontend source can serve
 as a reference implementation.
 .
 This is a header-only C++ library.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	-$(RM) -rfv include/contrib 
	-sed -e s@contrib/nlohmann/json/json.hpp@/usr/include/nlohmann/json.hpp@g \
		-i include/cudnn_frontend_Errata.h 

override_dh_auto_build:
	:

override_dh_auto_install:
	dh_auto_install

## nvidia-cudnn-frontend 1.6.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17)

project(cudnn_frontend VERSION 1.6.1)

option(CUDNN_FRONTEND_SKIP_JSON_LIB "Defines whether FE should not include nlohmann/json.hpp." OFF)
option(CUDNN_FRONTEND_BUILD_SAMPLES "Defines if samples are built or not." ON)
option(CUDNN_FRONTEND_BUILD_UNIT_TESTS "Defines if unittests are built or not." ON)

if(MSVC OR MSYS OR MINGW)
    option(CUDNN_FRONTEND_BUILD_PYTHON_BINDINGS "Defines if python bindings are built or not." OFF)
    add_compile_options(/W4 /WX)
else()
    option(CUDNN_FRONTEND_BUILD_PYTHON_BINDINGS "Defines if python bindings are built or not." OFF)
    add_compile_options(-Wall -Wextra -Wpedantic -Werror -Wno-error=attributes -Wno-attributes -Wno-error=unused-function -Wno-unused-function)
endif()

add_library(cudnn_frontend INTERFACE)

target_compile_definitions(
    cudnn_frontend INTERFACE
    $<$<BOOL:${CUDNN_FRONTEND_SKIP_JSON_LIB}>:CUDNN_FRONTEND_SKIP_JSON_LIB>
)

target_include_directories(
    cudnn_frontend INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# Find the cuda compiler
find_package(CUDAToolkit)

target_link_libraries(
    cudnn_frontend INTERFACE

    CUDA::cudart
    CUDA::nvrtc
)

target_compile_features(cudnn_frontend INTERFACE cxx_std_17)

# Make PCH for targets to link against
add_library(_cudnn_frontend_pch INTERFACE)
target_precompile_headers(_cudnn_frontend_pch INTERFACE ${PROJECT_SOURCE_DIR}/include/cudnn_frontend.h)

if (CUDNN_FRONTEND_BUILD_SAMPLES)
    add_subdirectory(samples)
endif()

if (CUDNN_FRONTEND_BUILD_UNIT_TESTS)
    add_subdirectory(test)
endif()

if (CUDNN_FRONTEND_BUILD_PYTHON_BINDINGS)
    add_subdirectory(python)
endif()

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

install(
    DIRECTORY ${PROJECT_SOURCE_DIR}/include/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

Include(FetchContent)

# Fetch and build dlpack
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
set(BUILD_MOCK OFF)
FetchContent_Declare(
  dlpack
  GIT_REPOSITORY https://github.com/dmlc/dlpack
  GIT_TAG        v0.8
)
FetchContent_MakeAvailable(dlpack)

# Find python
find_package(Python 3.8 COMPONENTS Interpreter Development.Module REQUIRED)

# Find cudnn
include(${PROJECT_SOURCE_DIR}/cmake/cuDNN.cmake)

option(CUDNN_FRONTEND_FETCH_PYBINDS_IN_CMAKE "Whether cmake build system should fetch pybinds." ON)

if(CUDNN_FRONTEND_FETCH_PYBINDS_IN_CMAKE)
    FetchContent_Declare(
        pybind11
        GIT_REPOSITORY https://github.com/pybind/pybind11
        GIT_TAG        v2.11.1
    )
    FetchContent_MakeAvailable(pybind11)
else()
    find_package(pybind11 CONFIG REQUIRED)
endif()

add_compile_options(-fvisibility=hidden)

# Add a library using FindPython's tooling (pybind11 also provides a helper like
# this)
python_add_library(
    _compiled_module
    
    MODULE
    pycudnn.cpp
    properties.cpp

    pygraph/pygraph.cpp
    pygraph/norm.cpp
    pygraph/sdpa.cpp
    pygraph/pointwise.cpp

    WITH_SOABI
)
target_link_libraries(_compiled_module PRIVATE pybind11::headers)

target_compile_features(_compiled_module PRIVATE cxx_std_17)

target_include_directories(
    _compiled_module
    PRIVATE $<TARGET_PROPERTY:cudnn_frontend,INTERFACE_INCLUDE_DIRECTORIES>
    PRIVATE $<TARGET_PROPERTY:CUDNN::cudnn_all,INTERFACE_INCLUDE_DIRECTORIES>
)

target_compile_definitions(_compiled_module PRIVATE NV_CUDNN_FRONTEND_USE_DYNAMIC_LOADING)

target_link_libraries(
    _compiled_module
    
    PRIVATE dlpack
)

set_target_properties(
    _compiled_module

    PROPERTIES
    LINK_FLAGS "-Wl,--no-as-needed"
    LINK_FLAGS "-Wl,--enable-new-dtags"
    LINK_FLAGS "-Wl,-rpath,'$ORIGIN',-rpath,'$ORIGIN/../lib',-rpath,'$ORIGIN/../nvidia/cudnn/lib'"
    LINK_WHAT_YOU_USE TRUE
)

# using python bindings directly with cmake build system is not supported
# Temparorily use below parameter
option(CUDNN_FRONTEND_KEEP_PYBINDS_IN_BINARY_DIR "Whether pybinds should be kept inside build/cudnn directory." ON)
if(CUDNN_FRONTEND_KEEP_PYBINDS_IN_BINARY_DIR)
set_target_properties(
        _compiled_module

        PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/cudnn
    )
    file(COPY ${PROJECT_SOURCE_DIR}/python/cudnn DESTINATION ${PROJECT_BINARY_DIR})
endif()

=== samples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

find_package(Catch2 QUIET)

find_package(Threads)

if(NOT Catch2_FOUND)
    Include(FetchContent)

    # Fetch and build catch2
    FetchContent_Declare(
      Catch2
      GIT_REPOSITORY https://github.com/catchorg/Catch2.git
      GIT_TAG        v3.3.2
    )
    FetchContent_MakeAvailable(Catch2)
endif()

# Find cudnn
include(${PROJECT_SOURCE_DIR}/cmake/cuDNN.cmake)

add_executable(
    samples
    
    cpp/sdpa/fp16_fwd.cpp
    cpp/sdpa/fp16_bwd.cpp
    cpp/sdpa/fp16_cached.cpp
    cpp/sdpa/fp16_benchmark.cpp
    cpp/sdpa/fp16_fwd_with_custom_dropout.cpp
    cpp/sdpa/fp8_fwd.cpp
    cpp/sdpa/fp8_bwd.cpp

    cpp/convolution/fprop.cpp
    cpp/convolution/fp8_fprop.cpp
    cpp/convolution/int8_fprop.cpp
    cpp/convolution/dgrads.cpp
    cpp/convolution/wgrads.cpp
    
    cpp/matmul/matmuls.cpp
    cpp/matmul/fp8_matmul.cpp
    cpp/matmul/int8_matmul.cpp
    cpp/matmul/mixed_matmul.cpp

    cpp/norm/batchnorm.cpp
    cpp/norm/layernorm.cpp
    cpp/norm/rmsnorm.cpp

    cpp/misc/serialization.cpp
    cpp/misc/autotuning.cpp
    cpp/misc/parallel_compilation.cpp
    cpp/misc/pointwise.cpp
    cpp/misc/resample.cpp
    cpp/misc/slice.cpp
    cpp/misc/sm_carveout.cpp

    legacy_samples/conv_sample.cpp 
    legacy_samples/test_list.cpp 
    legacy_samples/fp16_emu.cpp 
    legacy_samples/helpers.cpp 
    legacy_samples/fusion_sample.cpp 
    legacy_samples/fp8_sample.cpp 
    legacy_samples/norm_samples.cpp
    legacy_samples/fused_mha_sample.cpp
    legacy_samples/f16_flash_mha_sample.cpp
    legacy_samples/fp8_flash_mha_sample.cpp
)

if(DEFINED ENV{NO_DEFAULT_IN_SWITCH})
    message("Default case in the switch is disabled")
    add_compile_definitions(NO_DEFAULT_IN_SWITCH)
endif()

if (MSVC)
    target_compile_options(
        samples PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
        /bigobj # increase number of sections in .Obj file
    )
else()
    target_compile_options(
        samples PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()

target_link_libraries(
    samples

    PRIVATE Threads::Threads

    cudnn_frontend
    _cudnn_frontend_pch
    Catch2::Catch2WithMain


    CUDNN::cudnn
)

# cuDNN dlopen's its libraries
# Add all libraries in link line as NEEDED
set_target_properties(
    samples
    PROPERTIES
    LINK_WHAT_YOU_USE TRUE
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

add_subdirectory(unit_tests)

=== test/unit_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

find_package(Catch2 QUIET)

if(NOT Catch2_FOUND)
    Include(FetchContent)

    # Fetch and build catch2
    FetchContent_Declare(
      Catch2
      GIT_REPOSITORY https://github.com/catchorg/Catch2.git
      GIT_TAG        v3.3.2
    )
    FetchContent_MakeAvailable(Catch2)
endif()

# Find cudnn
include(${PROJECT_SOURCE_DIR}/cmake/cuDNN.cmake)

add_executable(
    unit_tests

    serialize.cpp
    validate.cpp
    version.cpp
)

if (MSVC)
    target_compile_options(
        unit_tests PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
        /bigobj # increase number of sections in .Obj file
    )
else()
    target_compile_options(
        unit_tests PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()

target_link_libraries(
    unit_tests
    cudnn_frontend
    _cudnn_frontend_pch
    Catch2::Catch2WithMain

    CUDNN::cudnn_all
)

# cuDNN dlopen's its libraries
# Add all libraries in link line as NEEDED
set_target_properties(
    unit_tests
    PROPERTIES
    LINK_WHAT_YOU_USE TRUE
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
)

=== debian/changelog ===
nvidia-cudnn-frontend (1.6.1+ds-1) unstable; urgency=medium

  * New upstream version 1.6.1+ds
    Please pin to this version for PyTorch/v2.4.X
  * rules: Specify build system to be none to avoid build failure.
  * rules: Update rules to get rid of the embedded nlohman/json.hpp
  * d/copyright: update for path change.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Oct 2024 02:05:56 -0400

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=none

override_dh_auto_configure:
	-$(RM) -rfv include/cudnn_frontend/thirdparty
	-sed -e s@cudnn_frontend/thirdparty/nlohmann/json.hpp@/usr/include/nlohmann/json.hpp@g \
		-i include/cudnn_frontend_utils.h

override_dh_auto_build:
	:

## nvidia-cudnn-frontend 1.8.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 cmake_minimum_required(VERSION 3.17)
 
-project(cudnn_frontend VERSION 1.6.1)
+project(cudnn_frontend VERSION 1.8.0)
 
 option(CUDNN_FRONTEND_SKIP_JSON_LIB "Defines whether FE should not include nlohmann/json.hpp." OFF)
 option(CUDNN_FRONTEND_BUILD_SAMPLES "Defines if samples are built or not." ON)
-option(CUDNN_FRONTEND_BUILD_UNIT_TESTS "Defines if unittests are built or not." ON)
+option(CUDNN_FRONTEND_BUILD_TESTS "Defines if unittests are built or not." ON)
 
 if(MSVC OR MSYS OR MINGW)
     option(CUDNN_FRONTEND_BUILD_PYTHON_BINDINGS "Defines if python bindings are built or not." OFF)
@@ -28,13 +28,11 @@
 )
 
 # Find the cuda compiler
-find_package(CUDAToolkit)
+find_package(CUDAToolkit REQUIRED)
 
-target_link_libraries(
+target_include_directories(
     cudnn_frontend INTERFACE
-
-    CUDA::cudart
-    CUDA::nvrtc
+    ${CUDAToolkit_INCLUDE_DIRS}
 )
 
 target_compile_features(cudnn_frontend INTERFACE cxx_std_17)
@@ -47,7 +45,7 @@
     add_subdirectory(samples)
 endif()
 
-if (CUDNN_FRONTEND_BUILD_UNIT_TESTS)
+if (CUDNN_FRONTEND_BUILD_TESTS)
     add_subdirectory(test)
 endif()

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 )
 target_link_libraries(_compiled_module PRIVATE pybind11::headers)
 
-target_compile_features(_compiled_module PRIVATE cxx_std_17)
+target_compile_features(_compiled_module PRIVATE cxx_std_20)
 
 target_include_directories(
     _compiled_module

=== samples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

find_package(Threads)

find_package(Catch2 QUIET)
if(NOT Catch2_FOUND)
    include(FetchContent)

    # Fetch and build catch2
    FetchContent_Declare(
        Catch2
        GIT_REPOSITORY https://github.com/catchorg/Catch2.git
        GIT_TAG        v3.3.2
    )
    FetchContent_MakeAvailable(Catch2)
endif()

include(${PROJECT_SOURCE_DIR}/cmake/cuDNN.cmake)

if(DEFINED ENV{NO_DEFAULT_IN_SWITCH})
    message("Default case in the switch is disabled")
    add_compile_definitions(NO_DEFAULT_IN_SWITCH)
endif()

# Add subdirectories for samples and legacy_samples
add_subdirectory(cpp)
add_subdirectory(legacy_samples)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

add_subdirectory(cpp)

=== samples/cpp/CMakeLists.txt ===
# target sources
add_executable(
    samples

    sdpa/fp16_fwd.cpp
    sdpa/fp16_bwd.cpp
    sdpa/fp16_cached.cpp
    sdpa/fp16_benchmark.cpp
    sdpa/fp16_fwd_with_custom_dropout.cpp
    sdpa/fp16_fwd_with_paged_caches.cpp
    sdpa/fp8_fwd.cpp
    sdpa/fp8_bwd.cpp

    convolution/fprop.cpp
    convolution/fp8_fprop.cpp
    convolution/int8_fprop.cpp
    convolution/dgrads.cpp
    convolution/wgrads.cpp

    matmul/matmuls.cpp
    matmul/fp8_matmul.cpp
    matmul/int8_matmul.cpp
    matmul/mixed_matmul.cpp

    norm/batchnorm.cpp
    norm/layernorm.cpp
    norm/rmsnorm.cpp

    misc/serialization.cpp
    misc/autotuning.cpp
    misc/parallel_compilation.cpp
    misc/pointwise.cpp
    misc/resample.cpp
    misc/slice.cpp
    misc/sm_carveout.cpp
    misc/cudagraphs.cpp
)

# target flags
if(MSVC)
    target_compile_options(
        samples PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
        /bigobj # increase number of sections in .Obj file
    )
else()
    target_compile_options(
        samples PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()

# target links
target_link_libraries(
    samples PRIVATE
    Threads::Threads
    Catch2::Catch2WithMain
    cudnn_frontend
    _cudnn_frontend_pch
    CUDNN::cudnn

    CUDA::cudart
    CUDA::cuda_driver # Needed as calls all CUDA calls will eventually move to driver
)

# target cmake properties
set_target_properties(
    samples PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
)

=== samples/legacy_samples/CMakeLists.txt ===
# target sources
add_executable(
    legacy_samples

    conv_sample.cpp
    test_list.cpp
    fp16_emu.cpp
    helpers.cpp
    fusion_sample.cpp
    fp8_sample.cpp
    norm_samples.cpp
    fused_mha_sample.cpp
    f16_flash_mha_sample.cpp
    fp8_flash_mha_sample.cpp
)

# target flags
if(MSVC)
    target_compile_options(
        legacy_samples PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
        /bigobj # increase number of sections in .Obj file
    )
else()
    target_compile_options(
        legacy_samples PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()

# target links
target_link_libraries(
    legacy_samples PRIVATE
    Threads::Threads
    Catch2::Catch2WithMain
    cudnn_frontend
    _cudnn_frontend_pch
    CUDNN::cudnn

    CUDA::cudart
)

# target cmake properties
set_target_properties(
    legacy_samples PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
)

=== test/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

find_package(Catch2 QUIET)

if(NOT Catch2_FOUND)
    Include(FetchContent)

    # Fetch and build catch2
    FetchContent_Declare(
      Catch2
      GIT_REPOSITORY https://github.com/catchorg/Catch2.git
      GIT_TAG        v3.3.2
    )
    FetchContent_MakeAvailable(Catch2)
endif()

# Find cudnn
include(${PROJECT_SOURCE_DIR}/cmake/cuDNN.cmake)

add_executable(
    tests

    pointwise_tests.cpp
    serialize.cpp
    validate.cpp
    version.cpp
    tensor.cpp
)

if (MSVC)
    target_compile_options(
        tests PRIVATE
        /W4 /WX # warning level 3 and all warnings as errors
        /wd4100 # allow unused parameters
        /wd4458 # local hides class member (currently a problem for all inline setters)
        /wd4505 # unreferenced function with internal linkage has been removed
        /wd4101 /wd4189 # unreferenced local
        /bigobj # increase number of sections in .Obj file
    )
else()
    target_compile_options(
        tests PRIVATE
        -Wall
        -Wextra
        -Werror
        -Wno-unused-function
    )
endif()

target_link_libraries(
    tests
    cudnn_frontend
    _cudnn_frontend_pch
    Catch2::Catch2WithMain

    CUDNN::cudnn

    CUDA::cudart
)

# cuDNN dlopen's its libraries
# Add all libraries in link line as NEEDED
set_target_properties(
    tests
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin
)

=== debian/changelog ===
nvidia-cudnn-frontend (1.8.0+ds-1) unstable; urgency=medium

  * New upstream version 1.8.0+ds
    Please pin to this version for PyTorch/v2.6.X
  * Install upstream samples as examples.

  [ Andreas Beckmann ]
  * Fix building twice in a row.
  * Simplify rules.
  * Refresh d/copyright.
  * Add upstream metadata.

 -- Mo Zhou <lumin@debian.org>  Tue, 04 Feb 2025 12:53:04 -0500

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
 Rules-Requires-Root: no
 
 Package: libcudnn-frontend-dev
-Section: contrib/libdevel
 Architecture: all
 Depends: ${misc:Depends}, nvidia-cudnn, nlohmann-json3-dev,
 Description: c++ wrapper for the cudnn backend API (development files)

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=none

override_dh_install:
	dh_install -X/thirdparty/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,repacksuffix=+ds,dversionmangle=auto" \
https://github.com/NVIDIA/cudnn-frontend/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
